# Icechunk

Here's a guide to setup UltiHash as IceChunk’s backend storage. Start by importing Icechunk, and configure UltiHash as the storage (including credentials).

```python
import icechunk

storage = icechunk.s3_storage(
    bucket="bucket-name",
    prefix="prefix-name",
    endpoint_url="<http://127.0.0.1:8080>",
    access_key_id="TEST-USER",
    secret_access_key="SECRET",
    allow_http=True
)
```

with:

1. The endpoint\_url parameter is set to the URL of the UltiHash cluster.
2. The UltiHash cluster is running over HTTP and not HTTPS, the allow\_http parameter must be set to True.
3. This describes a local machine setup. If the UltiHash cluster is deployed in the cloud, both the credentials (access\_key\_id and secret\_access\_key) and the endpoint\_url parameter must be adjusted in consequence.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ultihash.io/operations/prebuilt-connections/icechunk.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
